//
//		Out-Of-Memory situation
//			N E W   C++ standard - using "nothrow"
//			    on LINUX: gcc-compiler
//
//			Execption handling

#include <iostream>
#include <new>
#include <cstdlib>                  // abort
using namespace std;

void my_oom_handler()
{
  cout << "I hate these Out-Of-Memory messages." << endl;
  
  abort();	// Otherwise, "new" will try it agian and again and ...
}

int main()
{
 void (*old_oom_handler)();		// Pointer to old memory handler
 double *x;
    int n;
    
 cout << endl;
 cout << " Dimension of array = " ; cin >> n;
 
 old_oom_handler = set_new_handler(my_oom_handler);
 
 x = new double[n];			// Allocate memory
 
 cout << " ============" << endl;
 cout << " x  = " << x << endl << endl;
 

 if ( x == 0 )				// Check Out-Of-Memory
  {
    cout << " Out of Memory" << endl;
  }
 else
  {
    cout << n*sizeof(x[0]) << " Byte allocated" << endl;
    
    delete [] x;			// Deallocate memory
  }
 cout << endl;
 
 return 0; 
 }
 
 
 
 
 
 
 
 
 
