//	printvec.cpp
//
//		Includes definition for print routines used 
//		in  Ex751-old.cpp  and  Ex751.cpp
//
//	Compile with: g++ -c printvec.cpp
//	Produces  printvec.o 

#include <iostream>
using namespace std;

//-------------------------------------------------------------------
//		Print elements of a vector (length n)
//
void PrintVec(const int n, const double x[])
{
 int i;
 
 cout << endl;
 for (i=0; i<n; ++i)
  {
   cout << "  " << x[i];
  }
 cout << endl << endl; 
 return;
}

//-------------------------------------------------------------------
//		Print elements of a matrix 
//			(nrow rows and ncol columns)
//
void PrintMat(const int nrow, const int ncol, const double a[])
{
 int i,j;
 
 cout << endl;
 for (i=0; i<nrow; ++i)
  {
    cout << "Row " << i << ":";
    for (j=0; j<ncol; ++j)
     {
       cout << "  " << a[i*ncol+j] ;
     }
    cout << endl; 
  }
 cout << endl << endl; 
 return;
}
 
 
 
 
 
 
 
 
 
