//	studenten2.hpp

#include <iostream>
using namespace std;

class Studenten
{
//			Data in Studenten are private now!!
private:
  long int matrikel;
       int skz;
      char *pname, *pvorname;

//			Methods in Studenten
public:

//				Default constructor (no argument)
 Studenten();

//				Constructor with 4 arguments
 Studenten(const char vorname[], const char name[], 
       const long int  mat_nr = 0,   const int  skz_nr = 0);

//				Copy constructor
 Studenten(const Studenten& orig);

//				Destructor
 ~Studenten();

//				Assignment operator
 Studenten& operator=(const Studenten & orig);
 
//				Output operator
 friend ostream & operator<<(ostream  & s, const Studenten & orig);
//				Print method
 void Print(ostream  & s);
 
//		Methods to access the private data
//			Methods for data manipulation in Studenten

 void SetVorname(const char vorname[]);
 void SetName(const char name[]);
 void SetMatrikel(const long int  mat_nr);
 void SetSKZ(const int  skz_nr);

//			Methods that don't manipulate data in Studenten

 const long int& GetMatrikel() const;
 const int& GetSKZ() const;
 const char* GetVorname() const;
 const char* GetName() const;

};

 
 
 
 
 
 
 
 
