//	bung 4 - Aufgabe A
//	g++ u4A.cc

#include <iostream.h>
#include <math.h>

main()
{
 int    n,i;
 double *u, *w, h, s1,s2,s3;

 cout << endl;
 cout << "  Dynamische Vektorallokierung " << endl << endl;
 cout << "  Eingabe Vektordimension : ";
 cin  >> n;

//			Allocate the memory
 u = new double[n]; 
 w = new double[n]; 

//			Initialize the vectors
 h = 1.0/(n-1);		// Lenght of intervals
 
 for ( i=0; i<n; i++ )
  {
    u[i]   = sin(3*M_PI*h*i);		// Array notation
    *(w+i) = sin(5*M_PI*h*i);		// Pointer notation
  }
 
//			Calculate inner produvts
 s1 = 0.0;
 s2 = 0.0;
 s3 = 0.0;
 for ( i=0; i<n; i++ )
  {
    s1 += u[i] * u[i];			// Array - Array notation
    s2 += u[i] * *(w+i);		// Array - Pointer notation
    s3 += *(w+i) * *(w+i);		// Pointer-Pointer notation
  } 
 
 cout << "(u,u) = " << s1 << endl;
 cout << "(u,w) = " << s2 << endl;
 cout << "(w,w) = " << s3 << endl;

 cout << endl;

//			Deallocate memory (don't forget it !) 
 delete [] w;
 delete [] u;
}
