//	FuncMax.cpp
//	Exercise:
//	  given : Function (line ...) on [0,1]
//	  wanted: a) Maximum and Minimum of function on a given grid 
//			with nx and ny intervals. 
//		  b) Coordinates of the Maximum

#include <iostream>
using namespace std;

int main()
{
 double xa,xe,xi,xstride, ya,ye,yj,ystride, ff;
 double fmax,fmin, xmax, ymax;
 int    i,j,nx,ny;
 
 nx = 10;				//	# subintervals x
 ny = 10;				//	# subintervals y

 xa = 0.0e0;				//	# start interval x
 xe = 1.0e0;				//	# end   interval x
 xstride = (xe-xa)/nx;			//	length subinterval x

 ya = 0.0e0;				//	# start interval y
 ye = 1.0e0;				//	# end   interval y
 ystride = (ye-ya)/ny;			//	length subinterval y
 
// ---------------------------------------	Loop in int

 cout << endl <<  "Find Min. and Max." << endl;

//	Find max_double in header files
//						Initialize min, max 
 fmin = 1e30;
 fmax = -1e30;
 for (j = 0; j <= ny; ++j)		// 	Loop in y
   {
     yj = ya + j*ystride;
     for (i = 0; i <= nx; ++i)
       {
	xi = xa + i*xstride;

        ff = xi*(xe-xi)*yj;		//	Function: x(1-x)+y	
	
        if (ff < fmin) 
	  {
	    fmin = ff;			//	Set new (temp.) min.
	  }
//	else if (ff > fmax)		//	Improvement is wrong for max. in (0,0)!
					//	can be avoided by initializing 
					//		fmin=fmax=f(x,y) 
	if (ff > fmax)
	  {
	    fmax = ff;			//	Set new (temp.) max.
	    xmax = xi;
	    ymax = yj;
	  } 
       }
   }
 
 cout << endl;
 cout << "Minimum: " << fmin << endl;
 cout << "Maximum: " << fmax << " at (" << xmax << "," << ymax << ")" << endl; 
 cout << endl;

}
 
 
 
 
 
 
 
 
 
