//	pi4.cpp
//
//			Sum (-1)^k*4/(2k+1) = pi
//			limited accuracy
//			Is s1 or s2 closer to right result ?

#include <iostream>
#include <cmath>
using namespace std;

int main()
{
 float s1,s2;
 int k,n,n2,sign ;
 
 cout << endl << "Demo for precision of float" << endl;
 cout << endl << " n =  ";
 cin >> n;
// n = 65000;

//		Guarantee that last loop index n2 is an odd number!
 if (n % 2 == 1)
   {
     n2 = n;
   }
 else
   {
     n2 = n+1;
   }

 s1   = 0.0; 
 sign = 1;
//			loop over odd numbers
 for (k=1; k<=n2; k += 2)
   {
//    s1  += 4*sign/k;		// !! wrong: integer division !! 
     s1  += 4.0*sign/(float)k;
     sign = -sign;
   }
 
 cout << endl << "s1 = " << s1 << endl << endl;
 
 s2   = 0.0; 
 sign = 1;
//			inverse loop over odd numbers
 for (k=n2; k>=1; k -= 2)
   {
     s2  += 4.0*sign/(float)k;
     sign = -sign;
   }
 
 cout << endl << "s2 = " << s2 << endl << endl;
 
 cout << endl << "Diff " << s2-s1 << endl << endl;

 cout << endl << "PI - s1 : " << (float)M_PI-s1 << endl;
 cout << endl << "PI - s2 : " << (float)M_PI-s2 << endl << endl;

}
 
 
 
 
 
 
 
 
 
