//	HK2 Loesungsvorschlag
#include <iostream.h>
//----------    Datenstrukturen    ----------------------
struct Vector3D
 {
  double x,y,z;		// Die drei Vektorkomponenten
 };
//----------    Funktionen    ----------------------

void CrossProduct(const Vector3D & s, const Vector3D & t, Vector3D & r)
 {
  r.x = s.y * t.z - s.z * t.y;
  r.y = s.z * t.x - s.x * t.z;
  r.z = s.x * t.y - s.y * t.z;
  
  return;
 }

double ScalarProduct(const Vector3D & s, const Vector3D & t)
 {
  return s.x*t.x + s.y*t.y + s.z*t.z ;
 }

double SpatProduct(const Vector3D & s, const Vector3D & t, const Vector3D & r)
 {
  Vector3D tmp;
  
  CrossProduct(s,t,tmp);
  
  return ScalarProduct(tmp,r) ;
 }
//----------    Hauptprogramm    ----------------------
int main()
{
 Vector3D a = {0,1,2}, b = {3,2,0}, c;
 double   scal, spat;

 scal = ScalarProduct(a,b);	// a . b
 
 CrossProduct(a,b,c);		// a x b
 
 spat = SpatProduct(a,c,b);	// (a x c) . b 
 
 cout << "Scalar : " << scal << endl;
 cout << "Spat   : " << spat << endl;

 return 0;
} 
