//	K2 Loesungsvorschlag
#include <iostream.h>
#include <math.h>

void Folge(const int n, const double q, double a[])
{						// 1 Pkt. : Felder (beide Fkt)
 int i;
 
 for (i=0; i<=n; i++)
  {
   a[i] = pow(q,1.0/(i+1));			// 1 Pkt. : 1.0
  }
 
 return;
}						// 1 Pkt. : Fkt. korrekt

void Summen(const int n, const double a[], double s[])
{						// 1 Pkt. : const (beide Fkt)
 int i;
 
 s[0] = a[0];
 for (i=1; i<=n; i++)				// 1 Pkt.: i<=n
 {
  s[i] = s[i-1] + a[i];
 }
 
 return;
}						// 2 Pkt. : Fkt. korrekt


int main()
{
 const int N=10;
       int i;
    double a[N+1];			// 1 Pkt. : N+1
    double *s, q;
 
 s = new double [N+1];			// 1 Pkt. : new, *s
 
 cout << "Input q : "; cin >> q;	// 1 Pkt. : cin
 
 Folge(N, q, a );

 Summen(N, a, s);			// 1 Pkt. : Reihenfolge calls
 
 for (i=0; i<=N; i++)
 {
   cout << i << " : " << a[i] << "  ,  " << s[i] << endl;
 }
 
 delete [] s;				// 1 Pkt. : delete

 return 0;
} 
