//	K3	Fehler im Code
#include <iostream.h>

/*
// wrong
void myfunc(const int n, const double a[], const double & x)	// double
{
 double *b,s;							// xp
    int i;
 
 b = new double [n];
 
 xp = 1.0;
 for( i = 0; i < n; i++)
 {
   xp = xp*x;							// swap
   b[i] = a[i]*xp;						//   lines
 }
								// s = 0.0 
 for ( i = 1; i <= n; i++)					// i < n
   s += b[i]*b[i-1];
 								// delete [] b 
 return s;
}
*/

// correct
double myfunc(const int n, const double a[], const double & x)	// double
{
 double *b,s,xp;						// xp
    int i;
 
 b = new double [n];
 
 xp = 1.0;
 for( i = 0; i < n; i++)
 {
   b[i] = a[i]*xp;						// lines
   xp = xp*x;							//   swapped
 }
 
 s = 0.0;							// s = 0.0
 for ( i = 1; i < n; i++)					// i < n
   s += b[i]*b[i-1];
 
 delete [] b;							// delete [] b
 
 return s;
}



// Nur fuer Test

int main()
{
 const int N = 5;
    double a[N] = {5,4,3,2,1};
    double x,p;
 
 cout << "Input x : "; cin >> x;
 
 p = myfunc(N, a, x);

 cout << " p = " << p << endl;

 return 0;
}
