//	bung 6 - Aufgabe A/B

#include <iostream.h>

//			some general functions
double L2Norm(const int n, const double v[]);
void MaxPos(const int n, const double v[], int& kmax, double& amax);

//			I declare my own class

class MyVectorClass
{
private:
  double *u;
     int length;
     int kmax;
  double l2norm, amax;

//			Methods in MyVectorClass
public:

//				Default constructor (no argument)
 MyVectorClass();

//				Constructor with 1+1 arguments
 MyVectorClass(const int n, const int freq = 1);

//				Constructor with 1 file argument
 MyVectorClass(const char filename[]);

//				Copy constructor
 MyVectorClass(const MyVectorClass& orig);

//				Destructor
 ~MyVectorClass();

//				Assignment operator
 MyVectorClass& operator=(const MyVectorClass & orig);
 
//				Output operator
 friend ostream & operator<<(ostream  & s, const MyVectorClass & orig);

// 				Print function
 void Print() const;
//	Append the vector

 void Append(const int m);
 
//	Inner product with another vector

 double InnerProd(const MyVectorClass & right) const;

//	Calculate L2-Norm of a vector
//		(case n<=0 is included)

//double L2Norm(const int n, const double v[]);


//	Determine value and position of the absolute max in a vector
//		(case n<=0 is included)

//void MaxPos(const int n, const double v[], int& kmax, double& amax);



};
