//	bung 5 - Aufgabe A/B/C

//			I declare my own structure
struct MyVector
{
  double *u;
     int length;
     int kmax;
  double l2norm, amax;
};

//					Declare my functions

//	Allocate memory,  default value for n

void Define(MyVector& mv, const int n = 0);

//	Deallocate Memory

void Remove(MyVector& mv);

//	Copy one MyVector to another

void Copy(MyVector& left, const MyVector& right);

//	Initialize date in Structure

void Init(MyVector& mv, const int k);

//	Print data in MyVector

void Print(const MyVector& mv);


//	Calculate L2-Norm of a vector
//		(case n<=0 is included)

double L2Norm(const int n, const double v[]);


//	Determine value and position of the absolute max in a vector
//		(case n<=0 is included)

void MaxPos(const int n, const double v[], int& kmax, double& amax);

//	Append the vector

void Append(MyVector& mv, const int m);
