//	bung 3 - Aufgabe A
//	g++ u3A.cc

//	a.out < input.u3A{a,b}
//		a:   y = 2-x
//		b:   y = sqrt(2)-x/2

#include <iostream.h>

main()
{
 const int N = 10;
    double x[N], y[N], sigma[N];	// Input data
    double a, b;			// Line parameters
    double y_fit[N];			// fit data
    double sx,sy,s,t[N],stt,tmp;	// aux. data
       int i;
 
//		read data from input file as (x_i,y_i,sigma_i)
 for (i = 0; i < N; i++)
 {
   cin >> x[i] >> y[i] >> sigma[i];
 } 

//		Calculate S, Sx,Sy in one loop
  sx = sy = s = 0.0;
  for (i = 0; i < N; i++)
   {
     tmp = 1.0/sigma[i]/sigma[i];
     sx  = sx + x[i]*tmp;
     sy  = sy + y[i]*tmp;
     s   = s  + tmp;
   }

//		Calculate t[i], Stt
  tmp = sx/s;
  stt = 0.0;
  for (i = 0; i < N; i++)
   {
     t[i] = (x[i]-tmp)/sigma[i];
     stt = stt + t[i]*t[i];
   } 

//		Calculate b
  tmp = 0.0;
  for (i = 0; i < N; i++)
   {
     tmp = tmp + t[i]*y[i]/sigma[i];
   } 
  b = tmp/stt;

//		Calculate a
  a = (sy-sx*b)/s;
  
  cout << endl;
  cout << " Regression line" << endl;
  cout << " y = " << a << " + " << b << " * x" << endl;
  cout << endl;

// 		Calculate fit y
  for (i = 0; i < N; i++)
   {
    y_fit[i] = a + b* x[i];
   }

  cout << endl;
  cout << "Comparison" << endl;
  cout << "i \t x \t y_fit \t\t y \t sigma " << endl;
  for (i = 0; i < N; i++)
   {
    cout << i << "\t" << x[i] << "\t" << y_fit[i] << "  \t" 
         << y[i] << "\t" << sigma[i] << endl;
   }
  cout << endl;
}
