//	bung 4 - Aufgabe B
//	g++ u4B.cc

#include <iostream.h>
#include <math.h>

struct MyVector
{
  double *u;
     int length;
     int kmax;
  double l2norm, amax;
};

main()
{
 MyVector vec;
 double   h,s,smax,ui;
    int   i,imax;
    int   &n = vec.length;	// Reference
 
 cout << endl;
 cout << "  Struktur mit dynamischer Vektorallokierung " << endl << endl;
 cout << "  Eingabe Vektordimension : ";
 cin  >> n;
 
//			Allocate the memory
 vec.u = new double[n]; 

//			Initialize the vector
 h = 1.0/(n-1);		// Lenght of intervals
 
 for ( i=0; i<n; i++ )
  {
    vec.u[i]   = sin(3*M_PI*h*i);		// Array notation
  } 

//			Determine norm and max.
 s    = 0.0;
 imax = 0;
 smax = vec.u[imax];

 for ( i=0; i<n; i++)
  {
   ui = vec.u[i];
   s += ui * ui;
   if ( fabs(ui) > smax )
    {
      smax = fabs(ui);
      imax = i;
    }
  }
//			Store results in data structure
 vec.l2norm = sqrt(s);
 vec.amax   = smax;
 vec.kmax   = imax;
 
//			Print structure MyVector
 cout << endl;
 cout << " Ausgabe von Strukture MyVector" << endl;
 cout << " Vektor der Lnge " << vec.length << endl;
 for ( i=0; i<n; i++)  
     cout << vec.u[i] << "  " ;
 cout << endl;
 cout << " L2-norm = " << vec.l2norm << endl;
 cout << " Maximum = " << vec.amax << " an Position " << vec.kmax << endl;
 cout << endl;

//			Deallocate memory (don't forget it !) 
 delete [] vec.u; 
}
