//	bung 4 - Aufgabe C
//	g++ u4C.cc

#include <iostream.h>
#include <math.h>

struct MyVector
{
  double *u;
     int length;
     int kmax;
  double l2norm, amax;
};

main()
{
 MyVector u_vec, w_vec;
 double   h,s,smax,ui,si;
    int   i,imax,n, *i_vec;
 
 cout << endl;
 cout << "  Struktur mit dynamischer Vektorallokierung " << endl << endl;
 cout << "  Eingabe Vektordimension : ";
 cin  >> n;
 
//	-------------------------------------------------------------------
//			Initialize u_vec
//	-------------------------------------------------------------------

 u_vec.length = n;
//			Allocate the memory for u_vec
 u_vec.u = new double[n]; 
//			Initialize the vector
 h = 1.0/(n-1);		// Lenght of intervals
 
 for ( i=0; i<n; i++ )
  {
    u_vec.u[i]   = sin(3*M_PI*h*i);		// Array notation
  } 

//			Determine norm and max.
 s    = 0.0;
 imax = 0;
 smax = u_vec.u[imax];

 for ( i=0; i<n; i++)
  {
   ui = u_vec.u[i];
   s += ui * ui;
   if ( fabs(ui) > smax )
    {
      smax = fabs(ui);
      imax = i;
    }
  }
//			Store results in data structure
 u_vec.l2norm = sqrt(s);
 u_vec.amax   = smax;
 u_vec.kmax   = imax;
 
//	-------------------------------------------------------------------
//			Copy u_vec auf w_vec
//	-------------------------------------------------------------------
 w_vec.length = u_vec.length;
 w_vec.kmax   = u_vec.kmax;
 w_vec.l2norm = u_vec.l2norm; 
 w_vec.amax   = u_vec.amax ;
// w_vec.u = u_vec.u;			// uncomment for wrong code

//			Allocate the memory for w_vec
 w_vec.u = new double[w_vec.length]; 	// deactive for wrong code

//			Copy u_vec auf w_vec
 for ( i=0; i<n; i++)   		// comment for wrong code
     w_vec.u[i] = u_vec.u[i];  		// comment for wrong code


//	-------------------------------------------------------------------
//			inner product u,w
//	-------------------------------------------------------------------
 si = 0.0;
 for ( i=0; i<2*n; i++)  
     si += u_vec.u[i]*w_vec.u[i]; 
//	-------------------------------------------------------------------
//			Deallocate dynamic memory for u_vec
//	-------------------------------------------------------------------
 delete [] u_vec.u; 

//	-------------------------------------------------------------------
//			Allocate dynamic memory for int-vec
//				Initialize with 0
//	-------------------------------------------------------------------
 i_vec = new int [2*n];
 for ( i=0; i<2*n; i++)  
     i_vec[i] = 0; 
 
//	-------------------------------------------------------------------
//			Print structure w_vec
 cout << endl;
 cout << " inner Product (u,w) = " << si << endl << endl;
 cout << " Ausgabe von Strukture MyVector" << endl;
 cout << " Vektor der Lnge " << w_vec.length << endl;
 for ( i=0; i<w_vec.length; i++)  
     cout << w_vec.u[i] << "  " ;
 cout << endl;
 cout << " L2-norm = " << w_vec.l2norm << endl;
 cout << " Maximum = " << w_vec.amax << " an Position " << w_vec.kmax << endl;
 cout << endl;

//			Deallocate memory (don't forget it !) 
 delete [] w_vec.u; 
 delete [] i_vec; 
}
